<template>
  <ul class="word-list mt-4 list-disc max-h-[480px] overflow-scroll scroll-container">
    <li
      v-for="(word, index) in words"
      :key="index"
      :class="selectedIndex === index ? 'active' : ''"
      class="word-list-item flex justify-between font-medium gap-x-1 items-center list-disc relative group cursor-pointer"
      @click="emit('update-current-word', index)"
    >
      <div class="flex gap-x-2 items-center">
        <slot name="word-status" :word="word"></slot>
        {{ word.displayAs }}
      </div>
      <div class="hidden group-hover:block">
        <slot name="word-actions" :word="word"></slot>
      </div>
      <slot name="word-selected" :word="word"></slot>
      <CdxButton
        v-if="Object.keys(primaryAction).length != 0"
        weight="quiet"
        :aria-label="primaryAction.label"
        @click="emit('primary', word, index)"
      >
        <CdxIcon class="word-list-icon" :icon="primaryAction.icon" />
      </CdxButton>
    </li>
  </ul>
</template>

<script setup>
import { CdxButton, CdxIcon } from '@wikimedia/codex'

defineProps({
  words: {
    type: Array[String],
    required: true,
  },
  selectedIndex: {
    type: Number,
    default: -1,
  },
  primaryAction: {
    type: Object, // { label: String, icon: Codex Icon }
    default: () => ({}),
  },
})

const emit = defineEmits(['primary'])
</script>

<style>
.word-list {
  padding-left: 0px;
}

.word-list-icon.cdx-icon {
  color: grey;
}

.word-list-item {
  padding: 4px;
  padding-left: 16px;
  padding-right: 1em;
  border-radius: 15px 15px 15px 15px;
}

.word-list-item:hover {
  font-weight: bold;
  background-color: rgba(216, 222, 228, 0.5);
}

.word-list-item.active {
  font-weight: bold;
  background-color: #f8f9fa;
}
</style>
